<?php
/***************************************************************************
 *                                                                          *
 *   (c) 2004 Vladimir V. Kalynyak, Alexey V. Vinokurov, Ilya M. Shalnev    *
 *                                                                          *
 * This  is  commercial  software,  only  users  who have purchased a valid *
 * license  and  accept  to the terms of the  License Agreement can install *
 * and use this program.                                                    *
 *                                                                          *
 ****************************************************************************
 * PLEASE READ THE FULL TEXT  OF THE SOFTWARE  LICENSE   AGREEMENT  IN  THE *
 * "copyright.txt" FILE PROVIDED WITH THIS DISTRIBUTION PACKAGE.            *
 ****************************************************************************/

if (!defined('BOOTSTRAP')) {die('Access denied');}

@set_time_limit(300);

function getIp() {
    if (!empty($_SERVER["HTTP_CLIENT_IP"])) {
        $ip = $_SERVER["HTTP_CLIENT_IP"];
    } else if (!empty($_SERVER["HTTP_X_FORWARDED_FOR"])) {
        $ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
    } else if (!empty($_SERVER["REMOTE_ADDR"])) {
        $ip = $_SERVER["REMOTE_ADDR"];
    } else {
        $ip = "127.0.0.1";
    }

    return $ip;
}

/**
 * the function for creating uuid in PHP
 */
function create_guid() {
    $charid = strtoupper(md5(uniqid(mt_rand(), true)));
    $hyphen = chr(45); // "-"
    $uuid = substr($charid, 0, 8) . $hyphen
    . substr($charid, 8, 4) . $hyphen
    . substr($charid, 12, 4) . $hyphen
    . substr($charid, 16, 4) . $hyphen
    . substr($charid, 20, 12);
    return $uuid;
}

$params['amount'] = number_format($order_info['total'], 2, '.', '');
$params['currency'] = $processor_data['processor_params']['currency'];
$params['merchantid'] = $processor_data['processor_params']['merchant_id'];
$params['siteid'] = $processor_data['processor_params']['site_id'];
$params['invoiceid'] = $_REQUEST['order_id'] ? $_REQUEST['order_id'] : $order_info['repaid'];
$api_key = $processor_data['processor_params']['api_key'];
$gateway_url = $processor_data['processor_params']['gateway_url'];

//encrypted the sensitive data
$hash_info = hash("sha256", $params['merchantid'] . $params['siteid'] .
    $params['invoiceid'] . $params['amount'] . $params['currency'] . $api_key);

$curlPost = "order_amount=" . $params['amount'];
$curlPost .= "&order_currency=" . $params['currency'];
$curlPost .= "&mid=" . $params['merchantid'];
$curlPost .= "&site_id=" . $params['siteid'];
$curlPost .= "&oid=" . $params['invoiceid'];
$curlPost .= "&hash_info=" . $hash_info;

$curlPost .= "&card_no=" . $order_info['payment_info']['card_number'];
$curlPost .= "&card_ex_year=" . $order_info['payment_info']['expiry_year'];
$curlPost .= "&card_ex_month=" . $order_info['payment_info']['expiry_month'];
$curlPost .= "&card_cvv=" . $order_info['payment_info']['cvv2'];

$curlPost .= '&bill_firstname=' . $order_info['b_firstname'];
$curlPost .= '&bill_lastname=' . $order_info['b_lastname'];
$curlPost .= '&bill_street=' . $order_info['b_address'];
$curlPost .= '&bill_city=' . $order_info['b_city'];
$curlPost .= '&bill_state=' . $order_info['b_state'];
$curlPost .= '&bill_country=' . $order_info['b_country'];
$curlPost .= '&bill_zip=' . $order_info['b_zipcode'];
$curlPost .= '&bill_phone=' . $order_info['phone'];
$curlPost .= '&bill_email=' . $order_info['email'];

$curlPost .= '&syn_url=' . $_SERVER['HTTP_HOST'];
$curlPost .= '&asyn_url=' . $_SERVER['HTTP_HOST'];

$curlPost .= '&source_ip=' . getIp();
$curlPost .= '&source_url=' . $_SERVER["HTTP_REFERER"];
$curlPost .= '&gateway_version=1.0';
$curlPost .= '&uuid=' . create_guid();

parse_str($curlPost, $myArray);

//Registry::set('log_cut_data', array('cc_number', 'ccexp_month', 'ccexp_year', 'cnp_security'));
$result = Http::post($gateway_url, $myArray);

$pp_response['reason_text'] = '';
$response_code = '';

$arr = json_decode($result, true);

if (empty($result)) {
    $pp_response['reason_text'] = "Invalid response,please try again";
    $pp_response['order_status'] = 'F';
} else {
    if ($arr['data']['order_status'] == 2 || $arr['data']['order_status'] == 3) {
        $pp_response['reason_text'] = "Transaction approved";
        $pp_response['order_status'] = 'P';
    } else {
        $pp_response['reason_text'] = "Declined.|" . $arr['info'];
        $pp_response['order_status'] = 'F';
    }
}
